<?php

/**
 * ------------------------------------------------------------------------
 * BlueMind Stats Portal, aka bm-stats
 * ------------------------------------------------------------------------
 * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
 * @author  : Pascal SALAUN 
 * @Website : http://www.breizh-ltd.com <http://www.breizh-ltd.com>
 * ------------------------------------------------------------------------
 **/
 
function readDomainQuotaDatFile () {
  Global $path_to_data ;

    $thisArray = array();
    $thisArray['spaceRatio']['0']   = 0 ;
    $thisArray['spaceRatio']['50']  = 0 ;
    $thisArray['spaceRatio']['80']  = 0 ;
    $thisArray['spaceRatio']['90']  = 0 ;
    $thisArray['spaceRatio']['100'] = 0 ;
    $thisArray['spaceRatio']['101'] = 0 ;
    
    $thisFile = $path_to_data.$_SESSION['domainName']."/userQuota.dat" ;

    $line = file($thisFile);

    foreach ($line as $thisLine) {
        $ratio = 'N/A' ;
        /*
        file struct + exemple
        mbox,used space, applied quota
        reporting,136,51200
        */

        $values = explode(",", $thisLine);
         $mbox  = $values['0'];
         $space = $values['1'];
         $quota = $values['2'];

        if ($quota != 0)
            $ratio =  floor(($space/$quota)*10000)/100;

        $thisArray['mbox'][$mbox]['0'] = $space ;
        $thisArray['mbox'][$mbox]['1'] = $quota ;
        $thisArray['mbox'][$mbox]['2'] = $ratio ;

        if ($ratio == 'N/A')
            $thisArray['spaceRatio']['0']++ ;

        if($ratio <= 50) 
            $thisArray['spaceRatio']['50']++ ;

        if( ($ratio > 50) and ($ratio <= 80))
            $thisArray['spaceRatio']['80']++ ;

        if( ($ratio > 80) and ($ratio <= 90))
            $thisArray['spaceRatio']['90']++ ;

        if( ($ratio > 90) and ($ratio <= 100))
            $thisArray['spaceRatio']['100']++ ;

        if($ratio > 100)
            $thisArray['spaceRatio']['101']++ ;
    }

    return $thisArray ;

};


/*
From   : http://stackoverflow.com/questions/1597736/how-to-sort-an-array-of-associative-arrays-by-value-of-a-given-key-in-php 
Author : http://stackoverflow.com/users/1494102/zkanoca 

$result1 = array_msort($arr1, array('name'=>SORT_DESC);
$result2 = array_msort($arr1, array('cat'=>SORT_ASC);
$result3 = array_msort($arr1, array('name'=>SORT_DESC, 'cat'=>SORT_ASC));
*/
function array_msort($array, $cols) {

    $colarr = array();
    foreach ($cols as $col => $order) {
    $colarr[$col] = array();
        foreach ($array as $k => $row) { 
            $colarr[$col]['_'.$k] = strtolower($row[$col]); 
        }
    }

    $eval = 'array_multisort(';

    foreach ($cols as $col => $order) {
        $eval .= '$colarr[\''.$col.'\'],'.$order.',';
    }

    $eval = substr($eval,0,-1).');';
    eval($eval);
    $ret = array();
    foreach ($colarr as $col => $arr) {
        foreach ($arr as $k => $v) {
            $k = substr($k,1);
            if (!isset($ret[$k])) $ret[$k] = $array[$k];
            $ret[$k][$col] = $array[$k][$col];
        }
    }
    
    return $ret;
}



/*

Args : 

$case : size / quota
*/

function mostImportMailboxSize($thisArray,$case) {

    $thisMboxArray = $thisArray['mbox'] ;
    $thisOutOfZeroQuota = "" ;

    if($case == 'size')
        $thisNewArray = array_msort($thisMboxArray, array('0'=>SORT_DESC));


    if($case == 'quota')
        $thisNewArray = array_msort($thisMboxArray, array('2'=>SORT_DESC));

    // Because quota set to 0 have not to be displayed
    if($case == 'quota') {
      foreach (array_keys($thisNewArray) as $mbox ) {
          if ($thisNewArray[$mbox][2] != 'N/A') {  
              $thisOutOfZeroQuota[$mbox] = $thisNewArray[$mbox] ;
          };
      };
      $thisNewArray = $thisOutOfZeroQuota ;
    };

    if(!empty($thisNewArray))
      $slice = array_slice($thisNewArray, 0, 24, true);
    return $slice ;
}


function displayMostImportMailboxSize($values,$case) {

    Global $l_cyrusMbox,$l_cyrusSize,$l_cyusQuota,$l_cyrusTitleQuota,$l_cyrusTitleSize ;

    $html = "" ;

    $valuesBy  = mostImportMailboxSize($values,$case);

    if($case =='size') {
        $l_caseOrder = $l_cyrusTitleSize ;
    } else {
        $l_caseOrder = $l_cyrusTitleQuota ;
    };

    $html .=" 
      <div class='' id='ombreeXML' style='width: 98%; display: block'>
      <h1  id='xmlDarkGrey' class=''>$l_caseOrder </h1>
      <table width='100%' id=''>
      <caption>
      <td id='caption'>&nbsp; $l_cyrusMbox </td>
      <td id='caption'>&nbsp; $l_cyrusSize</td>
      <td id='caption'>&nbsp; $l_cyusQuota</td>
      </caption>";

      if(!empty($valuesBy)) {
          foreach (array_keys($valuesBy) as $mbox ){

              $thisSize  = print_in_KMGT_octet($valuesBy[$mbox][0]*1000) ;
              $thisRatio = $valuesBy[$mbox][2] ;

              $html .= "
                <tr>
                  <td>&nbsp; $mbox </td>
                  <td>&nbsp; $thisSize </td>
                  <td>&nbsp; $thisRatio %</td>
                </tr>";
          }
      };
    $html .="
      </table>
      </div>";

    return $html ;
}

?>
